define("smashthepigLuckMeter", ["viewBuilderApi", "componentmodelComponentApi", "clientkernelLoaderApi", "displayEngineApi", "smashthepigComponentsLuckMeterPort", "displayEngineUtils", "gameLayoutApi", "clientkernelEventbusApi", "clientkernelModulesApi"],
    function(viewBuilderApi, componentmodelComponentApi, clientkernelLoaderApi, displayEngineApi, smashthepigComponentsLuckMeterPort, displayEngineUtils, gameLayoutApi, clientkernelEventbusApi, clientkernelModulesApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

            get: function(k) {
                return {
                    arguments: ["*"],
                    returns: "null"
                };
            }
        };
        haxe.Log = function() {};
        haxe.Log.__name__ = ["haxe", "Log"];
        haxe.Log.trace = function(v, infos) {
            _hcmn_.js_Boot.__trace(v, infos);
        };
        haxe.Log.prototype.__class__ = haxe.Log;
        if (!haxe.ds) {
            haxe.ds = {};
        };
        haxe.ds.BalancedTree = function() {};
        haxe.ds.BalancedTree.__name__ = ["haxe", "ds", "BalancedTree"];
        haxe.ds.BalancedTree.prototype.root = null;
        haxe.ds.BalancedTree.prototype.set = function(key, value) {
            this.root = this.setLoop(key, value, this.root);
        };
        haxe.ds.BalancedTree.prototype.get = function(key) {
            var node = this.root;
            while (node != null) {
                var c = this.compare(key, node.key);
                if (c == 0) return node.value;
                if (c < 0) node = node.left;
                else node = node.right;
            }
            return null;
        };
        haxe.ds.BalancedTree.prototype.setLoop = function(k, v, node) {
            if (node == null) return new haxe.ds.TreeNode(null, k, v, null);
            var c = this.compare(k, node.key);
            if (c == 0) return new haxe.ds.TreeNode(node.left, k, v, node.right, node == null ? 0 : node._height);
            else if (c < 0) {
                var nl = this.setLoop(k, v, node.left);
                return this.balance(nl, node.key, node.value, node.right);
            } else {
                var nr = this.setLoop(k, v, node.right);
                return this.balance(node.left, node.key, node.value, nr);
            }
        };
        haxe.ds.BalancedTree.prototype.balance = function(l, k, v, r) {
            var hl;
            if (l == null) hl = 0;
            else hl = l._height;
            var hr;
            if (r == null) hr = 0;
            else hr = r._height;
            if (hl > hr + 2) {
                if ((function($this) {
                        var $r;
                        var _this = l.left;
                        $r = _this == null ? 0 : _this._height;
                        return $r;
                    }(this)) >= (function($this) {
                        var $r;
                        var _this1 = l.right;
                        $r = _this1 == null ? 0 : _this1._height;
                        return $r;
                    }(this))) return new haxe.ds.TreeNode(l.left, l.key, l.value, new haxe.ds.TreeNode(l.right, k, v, r));
                else return new haxe.ds.TreeNode(new haxe.ds.TreeNode(l.left, l.key, l.value, l.right.left), l.right.key, l.right.value, new haxe.ds.TreeNode(l.right.right, k, v, r));
            } else if (hr > hl + 2) {
                if ((function($this) {
                        var $r;
                        var _this2 = r.right;
                        $r = _this2 == null ? 0 : _this2._height;
                        return $r;
                    }(this)) > (function($this) {
                        var $r;
                        var _this3 = r.left;
                        $r = _this3 == null ? 0 : _this3._height;
                        return $r;
                    }(this))) return new haxe.ds.TreeNode(new haxe.ds.TreeNode(l, k, v, r.left), r.key, r.value, r.right);
                else return new haxe.ds.TreeNode(new haxe.ds.TreeNode(l, k, v, r.left.left), r.left.key, r.left.value, new haxe.ds.TreeNode(r.left.right, r.key, r.value, r.right));
            } else return new haxe.ds.TreeNode(l, k, v, r, (hl > hr ? hl : hr) + 1);
        };
        haxe.ds.BalancedTree.prototype.compare = function(k1, k2) {
            return _hcmn_.Reflect.compare(k1, k2);
        };
        haxe.ds.BalancedTree.prototype.__class__ = haxe.ds.BalancedTree;
        haxe.ds.TreeNode = function(l, k, v, r, h) {
            if (h == null) h = -1;
            this.left = l;
            this.key = k;
            this.value = v;
            this.right = r;
            if (h == -1) this._height = ((function($this) {
                var $r;
                var _this = $this.left;
                $r = _this == null ? 0 : _this._height;
                return $r;
            }(this)) > (function($this) {
                var $r;
                var _this1 = $this.right;
                $r = _this1 == null ? 0 : _this1._height;
                return $r;
            }(this)) ? (function($this) {
                var $r;
                var _this2 = $this.left;
                $r = _this2 == null ? 0 : _this2._height;
                return $r;
            }(this)) : (function($this) {
                var $r;
                var _this3 = $this.right;
                $r = _this3 == null ? 0 : _this3._height;
                return $r;
            }(this))) + 1;
            else this._height = h;
        };
        haxe.ds.TreeNode.__name__ = ["haxe", "ds", "TreeNode"];
        haxe.ds.TreeNode.prototype.left = null;
        haxe.ds.TreeNode.prototype.right = null;
        haxe.ds.TreeNode.prototype.key = null;
        haxe.ds.TreeNode.prototype.value = null;
        haxe.ds.TreeNode.prototype._height = null;
        haxe.ds.TreeNode.prototype.__class__ = haxe.ds.TreeNode;
        haxe.ds.EnumValueMap = function() {
            haxe.ds.BalancedTree.call(this);
        };
        haxe.ds.EnumValueMap.__interfaces__ = [haxe.IMap];
        haxe.ds.EnumValueMap.__name__ = ["haxe", "ds", "EnumValueMap"];
        haxe.ds.EnumValueMap.__super__ = haxe.ds.BalancedTree;
        for (var k in haxe.ds.BalancedTree.prototype) haxe.ds.EnumValueMap.prototype[k] = haxe.ds.BalancedTree.prototype[k];
        haxe.ds.EnumValueMap.prototype.compare = function(k1, k2) {
            var d = k1[1] - k2[1];
            if (d != 0) return d;
            var p1 = k1.slice(2);
            var p2 = k2.slice(2);
            if (p1.length == 0 && p2.length == 0) return 0;
            return this.compareArgs(p1, p2);
        };
        haxe.ds.EnumValueMap.prototype.compareArgs = function(a1, a2) {
            var ld = a1.length - a2.length;
            if (ld != 0) return ld;
            var _g1 = 0;
            var _g = a1.length;
            while (_g1 < _g) {
                var i = _g1++;
                var d = this.compareArg(a1[i], a2[i]);
                if (d != 0) return d;
            }
            return 0;
        };
        haxe.ds.EnumValueMap.prototype.compareArg = function(v1, v2) {
            if (_hcmn_.Reflect.isEnumValue(v1) && _hcmn_.Reflect.isEnumValue(v2)) return this.compare(v1, v2);
            else if ((v1 instanceof Array) && v1.__enum__ == null && ((v2 instanceof Array) && v2.__enum__ == null)) return this.compareArgs(v1, v2);
            else return _hcmn_.Reflect.compare(v1, v2);
        };
        haxe.ds.EnumValueMap.prototype.__class__ = haxe.ds.EnumValueMap;
        if (typeof js == 'undefined') {
            var js = {};
        };
        if (!js._Boot) {
            js._Boot = {};
        };
        js._Boot.HaxeError = function(val) {
            Error.call(this);
            this.val = val;
            this.message = String(val);
            if (Error.captureStackTrace) Error.captureStackTrace(this, js._Boot.HaxeError);
        };
        js._Boot.HaxeError.__name__ = ["js", "_Boot", "HaxeError"];
        js._Boot.HaxeError.__super__ = Error;
        for (var k in Error.prototype) js._Boot.HaxeError.prototype[k] = Error.prototype[k];
        js._Boot.HaxeError.prototype.val = null;
        js._Boot.HaxeError.prototype.__class__ = js._Boot.HaxeError;
        if (typeof smashthepigLuckMeter == 'undefined') {
            var smashthepigLuckMeter = {};
        };
        smashthepigLuckMeter.Activator = function(context) {};
        smashthepigLuckMeter.Activator = ck_implements(smashthepigLuckMeter.Activator, clientkernelModulesApi.IModuleActivator);
        smashthepigLuckMeter.Activator.__interfaces__ = [clientkernelModulesApi.IModuleActivator];
        smashthepigLuckMeter.Activator.__name__ = ["smashthepigLuckMeter", "Activator"];
        smashthepigLuckMeter.Activator.prototype.start = function(context) {
            context.getServiceTracker([viewBuilderApi.IViewBuilderFactory, clientkernelLoaderApi.IAssetRegistry, displayEngineApi.IDisplayProvider]).then(function(context1) {
                smashthepigLuckMeter.ExternalService.initialize(context1);
                var vbf = context1.getAnyService(viewBuilderApi.IViewBuilderFactory, null);
                smashthepigLuckMeter.ExternalService.viewBuilderFactory = vbf;
                context1.registerService(new smashthepigLuckMeter.LuckMeterFactory(vbf, context1), smashthepigComponentsLuckMeterPort.LuckMeterDeclaration, null);
            });
        };
        smashthepigLuckMeter.Activator.prototype.stop = function(context) {};
        smashthepigLuckMeter.Activator.main = function() {};
        smashthepigLuckMeter.Activator.prototype.__class__ = smashthepigLuckMeter.Activator;
        smashthepigLuckMeter.ExternalService = function() {};
        smashthepigLuckMeter.ExternalService.__name__ = ["smashthepigLuckMeter", "ExternalService"];
        smashthepigLuckMeter.ExternalService.displayProvider = null;
        smashthepigLuckMeter.ExternalService.assetRegistry = null;
        smashthepigLuckMeter.ExternalService.viewBuilderFactory = null;
        smashthepigLuckMeter.ExternalService.loadedConfig = null;
        smashthepigLuckMeter.ExternalService.configCallback = null;
        smashthepigLuckMeter.ExternalService.initialize = function(context) {
            smashthepigLuckMeter.ExternalService.displayProvider = context.getAnyService(displayEngineApi.IDisplayProvider, null);
            smashthepigLuckMeter.ExternalService.assetRegistry = context.getAnyService(clientkernelLoaderApi.IAssetRegistry, null);
        };
        smashthepigLuckMeter.ExternalService.loadConfig = function(config_id, configCallback) {
            smashthepigLuckMeter.ExternalService.configCallback = configCallback;
            smashthepigLuckMeter.ExternalService.assetRegistry.getAsset(config_id).getContent().then(function(data) {
                configCallback(data);
                smashthepigLuckMeter.ExternalService.loadedConfig = data;
            });
        };
        smashthepigLuckMeter.ExternalService.prototype.__class__ = smashthepigLuckMeter.ExternalService;
        smashthepigLuckMeter.LuckMeter = function(context, vbf) {
            this.initialized = false;
            this.layoutPayload = null;
            this.assetsLoaded = false;
            this.LAYOUT_CONFIG_ID = "luck-meter-layout-configuration";
            this.vbf = vbf;
            this.context = context;
            this.components = new haxe.ds.EnumValueMap();
            this.port = context.getImplementedPort(smashthepigComponentsLuckMeterPort.ILuckMeterImplementationPort);
            this.layoutPort = context.getUsedPort(gameLayoutApi.IGameLayoutPort);
            this.layoutPort.getUpdateComponentLayout().subscribe($bind(this, this.updateLayout));
            this.loadAssets();
        };
        smashthepigLuckMeter.LuckMeter.__name__ = ["smashthepigLuckMeter", "LuckMeter"];
        smashthepigLuckMeter.LuckMeter.prototype.view = null;
        smashthepigLuckMeter.LuckMeter.prototype.components = null;
        smashthepigLuckMeter.LuckMeter.prototype.layoutPort = null;
        smashthepigLuckMeter.LuckMeter.prototype.port = null;
        smashthepigLuckMeter.LuckMeter.prototype.context = null;
        smashthepigLuckMeter.LuckMeter.prototype.vba = null;
        smashthepigLuckMeter.LuckMeter.prototype.vbf = null;
        smashthepigLuckMeter.LuckMeter.prototype.LAYOUT_CONFIG_ID = null;
        smashthepigLuckMeter.LuckMeter.prototype.assetsLoaded = null;
        smashthepigLuckMeter.LuckMeter.prototype.layoutPayload = null;
        smashthepigLuckMeter.LuckMeter.prototype.initialized = null;
        smashthepigLuckMeter.LuckMeter.prototype.layerContainers = null;
        smashthepigLuckMeter.LuckMeter.prototype.loadAssets = function() {
            smashthepigLuckMeter.ExternalService.loadConfig(this.LAYOUT_CONFIG_ID, $bind(this, this.configLoaded));
        };
        smashthepigLuckMeter.LuckMeter.prototype.configLoaded = function(cfg) {
            var _g = this;
            var cfgId = cfg.vbAssetsId;
            smashthepigLuckMeter.ExternalService.assetRegistry.getAsset(cfgId).getContent().then(function(vba) {
                _g.vba = vba;
                _g.assetsLoaded = true;
                _g.initialize();
            });
        };
        smashthepigLuckMeter.LuckMeter.prototype.updateLayout = function(e) {
            this.layoutPayload = e.getPayload();
            if (!this.initialized) this.initialize();
            else this.handleUpdateLayout(this.layoutPayload);
        };
        smashthepigLuckMeter.LuckMeter.prototype.initialize = function() {
            if (!this.initialized && this.vba != null && this.layoutPayload != null) {
                this.view = this.vbf.createView(this.vba);
                this.registerAllComponents();
                this.handleUpdateLayout(this.layoutPayload);
                this.subscribeToAllPorts();
                this.initialized = true;
            }
        };
        smashthepigLuckMeter.LuckMeter.prototype.handleUpdateLayout = function(layoutPayload) {
            var $it0 = this.layerContainers.keys();
            while ($it0.hasNext()) {
                var layerId = $it0.next();
                var layerPayload = layoutPayload.containers.get(layerId);
                var stage;
                var this1 = smashthepigLuckMeter.ExternalService.displayProvider.getStages();
                stage = this1.get(layerPayload.stage);
                var container = this.layerContainers.get(layerId).getDisplayObject();
                try {
                    stage.removeChild(container);
                } catch (e) {
                    if (e instanceof js._Boot.HaxeError) e = e.val;
                    if (_hcmn_.js_Boot.__instanceof(e, Error)) {} else throw (e);
                }
                stage.addChild(container);
                container.setX(layerPayload.left);
                container.setY(layerPayload.top);
                container.setScaleX(layerPayload.width / container.getUserData().viewBuilderW);
                container.setScaleY(layerPayload.height / container.getUserData().viewBuilderH);
                container.setZIndex(layerPayload.zIndex);
            }
            this.layoutPort.getComponentLayoutUpdated().publish(this.context.getInstance());
        };
        smashthepigLuckMeter.LuckMeter.prototype.registerAllComponents = function() {
            this.layerContainers = this.view.getChildComponents();
            var $it0 = this.layerContainers.keys();
            while ($it0.hasNext()) {
                var layerId = $it0.next();
                var constructorIndex;
                var _this = _hcmn_.Type.getEnumConstructs(smashthepigLuckMeter.ComponentsEnum);
                constructorIndex = _hcmn_.HxOverrides.indexOf(_this, layerId, 0);
                if (constructorIndex < 0) continue;
                var componentEnum = _hcmn_.Type.createEnum(smashthepigLuckMeter.ComponentsEnum, layerId, null);
                this.registerContainerComponent(componentEnum, smashthepigLuckMeter.LuckMeterComponent);
            }
        };
        smashthepigLuckMeter.LuckMeter.prototype.registerContainerComponent = function(component, componentClass) {
            var container = this.view.getComponentById(component[0]);
            if (container == null) return;
            if (componentClass != null) {
                var specificComponent = _hcmn_.Type.createInstance(componentClass, [container]);
                this.components.set(component, specificComponent);
            } else this.components.set(component, container);
        };
        smashthepigLuckMeter.LuckMeter.prototype.subscribeToAllPorts = function() {
            this.port.getStartMeasure().subscribe($bind(this, this.handleStartMeasure));
            this.port.getShow().subscribe($bind(this, this.handleShow));
            this.port.getHide().subscribe($bind(this, this.handleHide));
            this.components.get(smashthepigLuckMeter.ComponentsEnum.LUCK_METER).getEvents().ON_FINISH().addListener($bind(this, this.handleOnFinish));
            this.components.get(smashthepigLuckMeter.ComponentsEnum.LUCK_METER).getEvents().ON_START().addListener($bind(this, this.handleOnStart));
        };
        smashthepigLuckMeter.LuckMeter.prototype.handleOnFinish = function(e) {
            this.port.getOnFinish().publish(null);
        };
        smashthepigLuckMeter.LuckMeter.prototype.handleOnStart = function(e) {
            this.port.getOnStart().publish(e);
        };
        smashthepigLuckMeter.LuckMeter.prototype.handleStartMeasure = function(e) {
            haxe.Log.trace("[mg]LuckMeter.handleStartMeasure()", {
                fileName: "LuckMeter.hx",
                lineNumber: 166,
                className: "smashthepig.components.luckMeter.LuckMeter",
                methodName: "handleStartMeasure"
            });
            this.components.get(smashthepigLuckMeter.ComponentsEnum.LUCK_METER).startMeasure(e.getPayload());
        };
        smashthepigLuckMeter.LuckMeter.prototype.handleShow = function(e) {
            haxe.Log.trace("[mg]LuckMeter.handleShow()", {
                fileName: "LuckMeter.hx",
                lineNumber: 171,
                className: "smashthepig.components.luckMeter.LuckMeter",
                methodName: "handleShow"
            });
            this.components.get(smashthepigLuckMeter.ComponentsEnum.LUCK_METER).show();
        };
        smashthepigLuckMeter.LuckMeter.prototype.handleHide = function(e) {
            haxe.Log.trace("[mg]LuckMeter.handleHide()", {
                fileName: "LuckMeter.hx",
                lineNumber: 176,
                className: "smashthepig.components.luckMeter.LuckMeter",
                methodName: "handleHide"
            });
            this.components.get(smashthepigLuckMeter.ComponentsEnum.LUCK_METER).hide();
        };
        smashthepigLuckMeter.LuckMeter.prototype.__class__ = smashthepigLuckMeter.LuckMeter;
        smashthepigLuckMeter.LuckMeterFactory = function(vbf, context) {
            this.context = context;
            this.vbf = vbf;
        };
        smashthepigLuckMeter.LuckMeterFactory = ck_implements(smashthepigLuckMeter.LuckMeterFactory, clientkernelModulesApi.IService);
        smashthepigLuckMeter.LuckMeterFactory = ck_implements(smashthepigLuckMeter.LuckMeterFactory, componentmodelComponentApi.IComponentFactory);
        smashthepigLuckMeter.LuckMeterFactory.__interfaces__ = [clientkernelModulesApi.IService, componentmodelComponentApi.IComponentFactory];
        smashthepigLuckMeter.LuckMeterFactory.__name__ = ["smashthepigLuckMeter", "LuckMeterFactory"];
        smashthepigLuckMeter.LuckMeterFactory.prototype.vbf = null;
        smashthepigLuckMeter.LuckMeterFactory.prototype.context = null;
        smashthepigLuckMeter.LuckMeterFactory.prototype.getComponentDeclaration = function() {
            return smashthepigComponentsLuckMeterPort.LuckMeterDeclaration;
        };
        smashthepigLuckMeter.LuckMeterFactory.prototype.createComponent = function(context) {
            new smashthepigLuckMeter.LuckMeter(context, this.vbf);
        };
        smashthepigLuckMeter.LuckMeterFactory.prototype.__class__ = smashthepigLuckMeter.LuckMeterFactory;
        smashthepigLuckMeter.LuckMeterComponent = function(container) {
            this.container = container;
            this.events = new smashthepigLuckMeter.LuckMeterEvents();
            this.cfg = smashthepigLuckMeter.ExternalService.loadedConfig;
            this.init();
        };
        smashthepigLuckMeter.LuckMeterComponent.__name__ = ["smashthepigLuckMeter", "LuckMeterComponent"];
        smashthepigLuckMeter.LuckMeterComponent.prototype.cfg = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.container = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.progressContainer = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.progress = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.progressMaxWidth = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.fillProcent = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.events = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.isLuckMeterDown = null;
        smashthepigLuckMeter.LuckMeterComponent.prototype.init = function() {
            this.progressContainer = this.container.getComponentById("ProgressBar");
            this.progress = this.progressContainer.getComponentById("ProgressMeter").getDisplayObject();
            this.progressMaxWidth = this.progress.getWidth();
            this.progress.setWidth(0);
            this.fillProcent = 0;
            this.isLuckMeterDown = 0;
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.calculate = function(fillPercents) {
            var step = this.progressMaxWidth / 100;
            return step * fillPercents;
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.calculateTime = function(fillPercents) {
            return this.cfg.progressDuration * (fillPercents / 100);
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.startMeasure = function(lmp) {
            haxe.Log.trace("[mg]LuckMeterComponent.startMeasure() ", {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 57,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "startMeasure",
                customParams: [lmp.getFillPercents()]
            });
            var w = this.calculate(lmp.getFillPercents());
            var t;
            if (lmp.getFillPercents() > 0) t = this.calculateTime(lmp.getFillPercents());
            else t = this.calculateTime(this.fillProcent);
            this.fillProcent = lmp.getFillPercents();
            if (this.progress.getWidth() > w && lmp.getFillPercents() == 0) this.isLuckMeterDown = 1;
            if (lmp.getFillPercents() >= 100) displayEngineUtils.TweenX.to(this.progress, {
                width: w
            }, null, null, null, null, null, null, null, null, {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 69,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "startMeasure"
            }).time(t).ease(displayEngineUtils.EaseX.bounceOut).onPlay($bind(this, this.onStart)).onFinish($bind(this, this.onFinish));
            else displayEngineUtils.TweenX.to(this.progress, {
                width: w
            }, null, null, null, null, null, null, null, null, {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 72,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "startMeasure"
            }).time(t).ease(displayEngineUtils.EaseX.bounceOut).onPlay($bind(this, this.onStart)).onFinish($bind(this, this.onFinish));
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.getEvents = function() {
            return this.events;
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.onStart = function() {
            haxe.Log.trace("[mg]LuckMeterComponent.onStart()", {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 81,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "onStart"
            });
            this.events.ON_START().dispatch(this.isLuckMeterDown);
            this.isLuckMeterDown = 0;
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.onFinish = function() {
            haxe.Log.trace("[mg]LuckMeterComponent.onFinish()", {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 88,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "onFinish"
            });
            this.events.ON_FINISH().dispatch();
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.show = function() {
            this.container.show();
            haxe.Log.trace("[mg]LuckMeterComponent.show()", {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 93,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "show"
            });
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.hide = function() {
            this.container.hide();
            haxe.Log.trace("[mg]LuckMeterComponent.hide()", {
                fileName: "LuckMeterComponent.hx",
                lineNumber: 97,
                className: "smashthepig.components.luckMeter.components.LuckMeterComponent",
                methodName: "hide"
            });
        };
        smashthepigLuckMeter.LuckMeterComponent.prototype.__class__ = smashthepigLuckMeter.LuckMeterComponent;
        smashthepigLuckMeter.ComponentsEnum = {
            __ename__: ["smashthepigLuckMeter", "ComponentsEnum"],
            __constructs__: ["LUCK_METER"]
        };
        smashthepigLuckMeter.ComponentsEnum.LUCK_METER = ["LUCK_METER", 0];
        smashthepigLuckMeter.ComponentsEnum.LUCK_METER.toString = $estr;
        smashthepigLuckMeter.ComponentsEnum.LUCK_METER.__enum__ = smashthepigLuckMeter.ComponentsEnum;
        smashthepigLuckMeter.BaseEvent = function() {
            this._signal = new _hcmn_.msignal_Signal1();
        };
        smashthepigLuckMeter.BaseEvent.__name__ = ["smashthepigLuckMeter", "BaseEvent"];
        smashthepigLuckMeter.BaseEvent.prototype._signal = null;
        smashthepigLuckMeter.BaseEvent.prototype.addListener = function(listener) {
            this._signal.add(listener);
        };
        smashthepigLuckMeter.BaseEvent.prototype.removeListener = function(listener) {
            this._signal.remove(listener);
        };
        smashthepigLuckMeter.BaseEvent.prototype.dispatch = function(data) {
            this._signal.dispatch(data);
        };
        smashthepigLuckMeter.BaseEvent.prototype.__class__ = smashthepigLuckMeter.BaseEvent;
        smashthepigLuckMeter.LuckMeterEvents = function() {
            this.onFinish = new smashthepigLuckMeter.BaseEvent();
            this.onStart = new smashthepigLuckMeter.BaseEvent();
        };
        smashthepigLuckMeter.LuckMeterEvents.__name__ = ["smashthepigLuckMeter", "LuckMeterEvents"];
        smashthepigLuckMeter.LuckMeterEvents.prototype.onFinish = null;
        smashthepigLuckMeter.LuckMeterEvents.prototype.onStart = null;
        smashthepigLuckMeter.LuckMeterEvents.prototype.ON_FINISH = function() {
            return this.onFinish;
        };
        smashthepigLuckMeter.LuckMeterEvents.prototype.ON_START = function() {
            return this.onStart;
        };
        smashthepigLuckMeter.LuckMeterEvents.prototype.__class__ = smashthepigLuckMeter.LuckMeterEvents;
        smashthepigLuckMeter.ExternalService.loadedAssets = new _hcmn_.haxe_ds_StringMap();;
        return {
            exports: smashthepigLuckMeter,
            activator: smashthepigLuckMeter.Activator
        };
    });
//# sourceURL=smashThePigLuckMeter.js